System-Upgrades
===

This component does the majority of host management. It utilises the `system-upgrades-controller` from Rancher to do this. It deploys longhorn volumes on the host-side, updates kubelet config, installs software and runs weekly system upgrades and takes care of reboot requirements. In order to make all of this safe, the operator takes care of cordoning, draining and uncordoning nodes before doing some of these operations.

It also provides a `calver-server`, that does nothing more than providing either weekly or monthly redirects in the `CalVer` format. This is used as channel provider for the weekly system upgrades.

Nice to knows
---

- Plans only run once unless their version changes or the secret that is assigned to them changes. However there is a `channel:` statement in the plan, that allows to provide a URL that **redirects** to a version. The controller will take the last component of the URL that the location-header of this redirect points to and uses that as version.

Links
---

- [Docs](https://github.com/rancher/system-upgrade-controller)
- [Source Code - CalVer-Server](https://git.shivering-isles.com/shivering-isles/calver-server)
