Calico
---

This component provides general networking to the cluster. The overlay network is kept simple since the goal are small scale clusters. However it uses Wireguard to encrypt all traffic within the cluster.

**Hint:** *This component also has a bootstrap component.*

Nice to knows
---

- <del>The operator provides its own set of CRDs, examples from the docs, won't work by default. Operator uses `crd.projectcalico.org/v1` while calico itself uses `projectcalico.org/v3`</del> You have to install the [calico API server](https://projectcalico.docs.tigera.io/maintenance/install-apiserver) in order to use the correct CRD versions. 
- metallb is required to be setup as host-endpoint in case you want to protect hosts with a `GlobalNetworkPolicy`.
- Additional network interfaces, like VPN interfaces, can confuse calico and result in routing everything over that VPN instead of the local network ports. Check the `projectcalico.org/IPv4Address`-annotation.

Links
---

- [Docs](https://projectcalico.docs.tigera.io/about/about-calico)
- [Helm Chart](https://artifacthub.io/packages/helm/projectcalico/tigera-operator)
- [Source Code - Operator](https://github.com/tigera/operator)
- [Source Code - Calico](https://github.com/projectcalico/calico)
